import { aw as Json } from './channel-e0a7355c';
import { e as LogHandlerOptions, a as LogMessage, b as LogHandler } from './log-d606e2f7';

declare type csvOptions = {
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
};
declare function stringToPath(value?: string): string;
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: any;
    parsed?: undefined;
};

declare class FileStorage {
    private store;
    private dirname;
    private fileKeys?;
    constructor(basePath?: string);
    setItem(key: string, value: Json): void;
    getItem(key: string): Json | null;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

export { FileStorage as F, LoggerFileHandler as L, setupEnv as a, LoggerNodeHandler as b, stringToPath as s };
